commit ebf561429ee4fbd125aa51ee985e32f1cfd4daed
Author: Kyrylo Tkachov <ktkachov@nvidia.com>
Date:   Thu Jun 27 16:10:41 2024 +0530

    aarch64: PR target/115457 Implement missing __ARM_FEATURE_BF16 macro
    
    The ACLE asks the user to test for __ARM_FEATURE_BF16 before using the
    <arm_bf16.h> header but GCC doesn't set this up.
    LLVM does, so this is an inconsistency between the compilers.
    
    This patch enables that macro for TARGET_BF16_FP.
    Bootstrapped and tested on aarch64-none-linux-gnu.
    
    gcc/
    
            PR target/115457
            * config/aarch64/aarch64-c.cc (aarch64_update_cpp_builtins):
            Define __ARM_FEATURE_BF16 for TARGET_BF16_FP.
    
    gcc/testsuite/
    
            PR target/115457
            * gcc.target/aarch64/acle/bf16_feature.c: New test.
    
    Signed-off-by: Kyrylo Tkachov <ktkachov@nvidia.com>
    (cherry picked from commit c10942134fa759843ac1ed1424b86fcb8e6368ba)

diff --git a/gcc/config/aarch64/aarch64-c.cc b/gcc/config/aarch64/aarch64-c.cc
index a4c407724a7..b31b967c140 100644
--- a/gcc/config/aarch64/aarch64-c.cc
+++ b/gcc/config/aarch64/aarch64-c.cc
@@ -200,6 +200,8 @@ aarch64_update_cpp_builtins (cpp_reader *pfile)
 			"__ARM_FEATURE_BF16_VECTOR_ARITHMETIC", pfile);
   aarch64_def_or_undef (TARGET_BF16_FP,
 			"__ARM_FEATURE_BF16_SCALAR_ARITHMETIC", pfile);
+  aarch64_def_or_undef (TARGET_BF16_FP,
+			"__ARM_FEATURE_BF16", pfile);
   aarch64_def_or_undef (TARGET_LS64,
 			"__ARM_FEATURE_LS64", pfile);
   aarch64_def_or_undef (AARCH64_ISA_RCPC, "__ARM_FEATURE_RCPC", pfile);
diff --git a/gcc/testsuite/gcc.target/aarch64/acle/bf16_feature.c b/gcc/testsuite/gcc.target/aarch64/acle/bf16_feature.c
new file mode 100644
index 00000000000..96584b4b988
--- /dev/null
+++ b/gcc/testsuite/gcc.target/aarch64/acle/bf16_feature.c
@@ -0,0 +1,10 @@
+/* { dg-do compile } */
+
+#pragma GCC target "+bf16"
+#ifndef __ARM_FEATURE_BF16
+#error "__ARM_FEATURE_BF16 is not defined but should be!"
+#endif
+
+void
+foo (void) {}
+

